typedef struct BitModel {
	int order;
	PValPair model;
	UINT context;
	UINT mask;
	ValPair tmp;
} BitModel, *PBitModel;
PBitModel InitBM(int modelOrder) {
	LONG init;
	PBitModel bm = (PBitModel) MemAlloc(sizeof(BitModel));
	bm->order = modelOrder;
	bm->mask = (1 << modelOrder) - 1;
	bm->context = 0;
	bm->model = (PValPair) MemAlloc(sizeof(ValPair) * (bm->mask + 1));
	if(IsInvalidPtr(bm->model)) { 
		MemFree(bm);
		return NULL;
	};
	for(init = 0; init <= bm->mask; init++) {
		bm->model[init].v0 = 1;
		bm->model[init].vt = 2;
	};
	return bm;
};
__forceinline UINT BMP1(PBitModel bm) {
	bm->tmp = bm->model[bm->context];
	return ((LONG) bm->tmp.v0 * (LONG) 0xFFFFFFFF) / ((LONG) bm->tmp.vt);
};
__forceinline void BMUpdate(PBitModel bm, BOOL bit) {
	bm->model[bm->context].vt++;
	if(bit == FALSE) { 
		bm->model[bm->context].v0++;
		bm->context = (bm->context << 1) & bm->mask;
	} else {
		bm->context = ((bm->context << 1) | 1) & bm->mask;
	};
};
void DestroyBM(PBitModel bm) {
	MemFree(bm->model);
	MemFree(bm);
};