typedef struct MiniBitModel {
	ValPair c[2];
	BYTE last;
} MBitModel, *PMBitModel;
typedef struct DoubleBitModel {
	int order;
	PMBitModel model;
	UINT context;
	UINT mask;
	ValPair tmp;
	MBitModel temp;
} DBitModel, *PDBitModel;
PDBitModel InitDBM(int modelOrder) {
	LONG init;
	PDBitModel bm = (PDBitModel) MemAlloc(sizeof(DBitModel));
	bm->order = modelOrder;
	bm->mask = (1 << modelOrder) - 1;
	bm->context = 0;
	bm->model = (PMBitModel) MemAlloc(sizeof(MBitModel) * (bm->mask + 1));
	if(IsInvalidPtr(bm->model)) { 
		MemFree(bm);
		return NULL;
	};
	for(init = 0; init <= bm->mask; init++) {
		bm->model[init].c[0].v0 = 1;
		bm->model[init].c[0].vt = 2;
		bm->model[init].c[1].v0 = 1;
		bm->model[init].c[1].vt = 2;
		bm->model[init].last = (BYTE) FALSE;
	};
	return bm;
};
__forceinline UINT DBMP1(PDBitModel bm) {
	bm->temp = bm->model[bm->context];
	bm->tmp = bm->temp.c[bm->temp.last];
	return ((LONG) bm->tmp.v0 * (LONG) 0xFFFFFFFF) / ((LONG) bm->tmp.vt);
};
__forceinline void DBMUpdate(PDBitModel bm, BOOL bit) {
	bm->model[bm->context].c[bm->model[bm->context].last].vt++;
	if(bit == FALSE) {
		bm->model[bm->context].c[bm->model[bm->context].last].v0++;
		bm->model[bm->context].last = (BYTE) bit;
		bm->context = (bm->context << 1) & bm->mask;
	} else {
		bm->model[bm->context].last = (BYTE) bit;
		bm->context = ((bm->context << 1) | 1) & bm->mask;
	};
};
void DestroyDBM(PDBitModel bm) {
	MemFree(bm->model);
	MemFree(bm);
};