ValPair noprob32;
typedef struct RangeCoder32 {
	PBUFFERED_FILE baseFile;
	BOOL first;
	LONG loVal;
	LONG hiVal;
	LONG range;
	LONG curVal;
	BOOL bitVal;
	LONG rangeHi;
	LONG rangeLo;
	LONG writeCount;
	LONG readCount;
	LONG tempInt;
	BOOL atEnd;
} RangeCoder32, *PRangeCoder32;
PRangeCoder32 InitRC32(PBUFFERED_FILE file) {
	PRangeCoder32 rc = (PRangeCoder32) MemAlloc(sizeof(RangeCoder32));
	rc->baseFile = file;
	rc->first = TRUE;
	rc->loVal = 0;
	rc->hiVal = 4294967295;
	rc->range = 0;
	rc->curVal = 0;
	rc->bitVal = FALSE;
	rc->rangeHi = 0;
	rc->rangeLo = 0;
	rc->writeCount = 0;
	rc->readCount = 0;
	rc->atEnd = FALSE;
	rc->tempInt = 0;
	noprob32.v0 = 1;
	noprob32.vt = 4294967295;
	return rc;
};
void RC32GetRange(PRangeCoder32 rc, UINT prob) {
	rc->range = rc->hiVal - rc->loVal + 1;
	//rc->rangeLo = (((rc->range * ((LONG) prob.v0) << 1) / ((LONG) prob.vt)) + 1) >> 1;
	//rc->rangeLo = (rc->range * (LONG) prob.v0) / ((LONG) prob.vt);
	rc->rangeLo = (rc->range * (LONG) prob) >> 32;
	rc->rangeHi = rc->range - rc->rangeLo;
	if(rc->rangeLo == 0) {
		rc->rangeLo = 1;
		rc->rangeHi--;
	};
	if(rc->rangeHi == 0) {
		rc->rangeHi = 1;
		rc->rangeLo--;
	};
};
void RC32EncodeBit(PRangeCoder32 rc, BOOL bit, UINT prob) {
	RC32GetRange(rc, prob);
	if(bit == TRUE) {
		rc->loVal = rc->hiVal - (rc->rangeHi - 1);
	} else {
		rc->hiVal = rc->loVal + (rc->rangeLo - 1);
	};
	if(rc->loVal >= rc->hiVal) {
		WriteBufferedByte(rc->baseFile, (BYTE) ((rc->loVal >> 24) & 0xFF));
		WriteBufferedByte(rc->baseFile, (BYTE) ((rc->loVal >> 16) & 0xFF));
		WriteBufferedByte(rc->baseFile, (BYTE) ((rc->loVal >> 8) & 0xFF));
		WriteBufferedByte(rc->baseFile, (BYTE) (rc->loVal & 0xFF));
		rc->writeCount++;
		rc->loVal = 0;
		rc->hiVal = 4294967295;
	};
};
BOOL RC32DecodeBit(PRangeCoder32 rc, UINT prob) {
	if(rc->first) {
		rc->tempInt = ReadBufferedByte(rc->baseFile);
		if(rc->tempInt == -1) {
			rc->atEnd = TRUE;
			return FALSE;
		};
		rc->curVal = rc->tempInt << 24;
		rc->tempInt = ReadBufferedByte(rc->baseFile);
		if(rc->tempInt == -1) {
			rc->atEnd = TRUE;
			return FALSE;
		};
		rc->curVal |= rc->tempInt << 16;
		rc->tempInt = ReadBufferedByte(rc->baseFile);
		if(rc->tempInt == -1) {
			rc->atEnd = TRUE;
			return FALSE;
		};
		rc->curVal |= rc->tempInt << 8;
		rc->tempInt = ReadBufferedByte(rc->baseFile);
		if(rc->tempInt == -1) {
			rc->atEnd = TRUE;
			return FALSE;
		};
		rc->curVal |= rc->tempInt;
		rc->readCount++;
		rc->first = FALSE;
	};
	RC32GetRange(rc, prob);
	if((rc->curVal >= rc->loVal) && (rc->curVal <= (rc->loVal + (rc->rangeLo - 1)))) {
		rc->bitVal = FALSE;
		rc->hiVal = rc->loVal + (rc->rangeLo - 1);
	} else {
		rc->bitVal = TRUE;
		rc->loVal = rc->hiVal - (rc->rangeHi - 1);
	};
	if(rc->loVal >= rc->hiVal) {
		rc->tempInt = ReadBufferedByte(rc->baseFile);
		if(rc->tempInt == -1) {
			rc->atEnd = TRUE;
			return FALSE;
		};
		rc->curVal = rc->tempInt << 24;
		rc->tempInt = ReadBufferedByte(rc->baseFile);
		if(rc->tempInt == -1) {
			rc->atEnd = TRUE;
			return FALSE;
		};
		rc->curVal |= rc->tempInt << 16;
		rc->tempInt = ReadBufferedByte(rc->baseFile);
		if(rc->tempInt == -1) {
			rc->atEnd = TRUE;
			return FALSE;
		};
		rc->curVal |= rc->tempInt << 8;
		rc->tempInt = ReadBufferedByte(rc->baseFile);
		if(rc->tempInt == -1) {
			rc->atEnd = TRUE;
			return FALSE;
		};
		rc->curVal |= rc->tempInt;
		rc->readCount++;
		rc->loVal = 0;
		rc->hiVal = 4294967295;
	};
	return rc->bitVal;
};
void RC32Flush(PRangeCoder32 rc) {
	if((rc->loVal > 0) || (rc->hiVal < 4294967295)) { RC32EncodeBit(rc, FALSE, 1); };
	FlushBufferedFile(rc->baseFile, FALSE);
};
void DestroyRC32(PRangeCoder32 rc) {
	MemFree(rc);
};